#include <sys/mman.h>
#include <stdio.h>
#include <fcntl.h>

unsigned int szbuf = 4096; // This needs to be a power of two in order for the ring buffer to work.
unsigned int szmmap = szbuf + 4096; // The size of the shared memory. It must be at least szbuf + 2*sizeof(int)
char const * mmap_filename = "1234"; // The name of the shared file

#define smp_wmb() \
	asm volatile("sfence" ::: "memory")

/* These are adapted from <linux/circ_buf.h>, which is why this code is GPL'ed.
 * You can read more at http://lwn.net/Articles/378262/
 */

/* Return count in buffer.  */
#define CIRC_CNT(head,tail,size) (((head) - (tail)) & ((size)-1))

/* Return space available, 0..size-1.  We always leave one free char
   as a completely full buffer has head == tail, which is the same as
   empty.  */
#define CIRC_SPACE(head,tail,size) CIRC_CNT((tail),((head)+1),(size))

/* Return count up to the end of the buffer.  Carefully avoid
   accessing head and tail more than once, so they can change
   underneath us without returning inconsistent results.  */
#define CIRC_CNT_TO_END(head,tail,size) \
	({int end = (size) - (tail); \
	  int n = ((head) + end) & ((size)-1); \
	  n < end ? n : end;})

/* Return space available up to the end of the buffer.  */
#define CIRC_SPACE_TO_END(head,tail,size) \
	({int end = (size) - 1 - (head); \
	  int n = (end + (tail)) & ((size)-1); \
	  n <= end ? n : end+1;})

